org.springframework.core.type.classreading

## Class AnnotationMetadataReadingVisitor

- java.lang.Object
- - org.springframework.asm.ClassVisitor
  - - org.springframework.core.type.classreading.AnnotationMetadataReadingVisitor

- All Implemented Interfaces:
    AnnotatedTypeMetadata, AnnotationMetadata, ClassMetadata

      public class AnnotationMetadataReadingVisitor
      extends ClassVisitor
      implements AnnotationMetadata

  ASM class visitor which looks for the class name and implemented types as well as for the annotations defined on the class, exposing them through the `AnnotationMetadata` interface.
  Since:
    2.5
  Author:
    Juergen Hoeller, Mark Fisher, Costin Leau, Phillip Webb, Sam Brannen

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Set<String>` | `annotationSet`
    `protected LinkedMultiValueMap<String,AnnotationAttributes>` | `attributesMap` Declared as a `LinkedMultiValueMap` instead of a `MultiValueMap` to ensure that the hierarchical ordering of the entries is preserved.
    `protected ClassLoader` | `classLoader`
    `protected Map<String,Set<String>>` | `metaAnnotationMap`
    `protected Set<MethodMetadata>` | `methodMetadataSet`

    - ### Fields inherited from class org.springframework.asm.ClassVisitor

      `api, cv`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `AnnotationMetadataReadingVisitor(ClassLoader classLoader)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `MultiValueMap<String,Object>` | `getAllAnnotationAttributes(String annotationType)` Retrieve all attributes of all annotations of the given type, if any (i.e.
    `MultiValueMap<String,Object>` | `getAllAnnotationAttributes(String annotationType, boolean classValuesAsString)` Retrieve all attributes of all annotations of the given type, if any (i.e.
    `Set<MethodMetadata>` | `getAnnotatedMethods(String annotationType)` Retrieve the method metadata for all methods that are annotated (or meta-annotated) with the given annotation type.
    `AnnotationAttributes` | `getAnnotationAttributes(String annotationType)` Retrieve the attributes of the annotation of the given type, if any (i.e.
    `AnnotationAttributes` | `getAnnotationAttributes(String annotationType, boolean classValuesAsString)` Retrieve the attributes of the annotation of the given type, if any (i.e.
    `Set<String>` | `getAnnotationTypes()` Return the names of all annotation types that are present on the underlying class.
    `String` | `getClassName()` Return the name of the underlying class.
    `String` | `getEnclosingClassName()` Return the name of the enclosing class of the underlying class, or `null` if the underlying class is a top-level class.
    `String[]` | `getInterfaceNames()` Return the names of all interfaces that the underlying class implements, or an empty array if there are none.
    `String[]` | `getMemberClassNames()` Return the names of all classes declared as members of the class represented by this ClassMetadata object.
    `Set<String>` | `getMetaAnnotationTypes(String annotationType)` Return the names of all meta-annotation types present on the given annotation type on the underlying class.
    `String` | `getSuperClassName()` Return the name of the super class of the underlying class, or `null` if there is no super class defined.
    `boolean` | `hasAnnotatedMethods(String annotationType)` Determine whether the underlying class has any methods that are annotated (or meta-annotated) with the given annotation type.
    `boolean` | `hasAnnotation(String annotationType)` Determine whether an annotation of the given type is present on the underlying class.
    `boolean` | `hasEnclosingClass()` Return whether the underlying class has an enclosing class (i.e.
    `boolean` | `hasMetaAnnotation(String metaAnnotationType)` Determine whether the underlying class has an annotation that is itself annotated with the meta-annotation of the given type.
    `boolean` | `hasSuperClass()` Return whether the underlying class has a super class.
    `boolean` | `isAbstract()` Return whether the underlying class is marked as abstract.
    `boolean` | `isAnnotated(String annotationType)` Determine whether the underlying type has an annotation or meta-annotation of the given type defined.
    `boolean` | `isConcrete()` Return whether the underlying class represents a concrete class, i.e.
    `boolean` | `isFinal()` Return whether the underlying class is marked as 'final'.
    `boolean` | `isIndependent()` Determine whether the underlying class is independent, i.e.
    `boolean` | `isInterface()` Return whether the underlying class represents an interface.
    `void` | `visit(int version, int access, String name, String signature, String supername, String[] interfaces)` Visits the header of the class.
    `AnnotationVisitor` | `visitAnnotation(String desc, boolean visible)` Visits an annotation of the class.
    `void` | `visitAttribute(Attribute attr)` Visits a non standard attribute of the class.
    `void` | `visitEnd()` Visits the end of the class.
    `FieldVisitor` | `visitField(int access, String name, String desc, String signature, Object value)` Visits a field of the class.
    `void` | `visitInnerClass(String name, String outerName, String innerName, int access)` Visits information about an inner class.
    `MethodVisitor` | `visitMethod(int access, String name, String desc, String signature, String[] exceptions)` Visits a method of the class.
    `void` | `visitOuterClass(String owner, String name, String desc)` Visits the enclosing class of the class.
    `void` | `visitSource(String source, String debug)` Visits the source of the class.

    - ### Methods inherited from class org.springframework.asm.ClassVisitor

      `visitTypeAnnotation`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.springframework.core.type.ClassMetadata

      `getClassName, getEnclosingClassName, getInterfaceNames, getMemberClassNames, getSuperClassName, hasEnclosingClass, hasSuperClass, isAbstract, isConcrete, isFinal, isIndependent, isInterface`

- - ### Field Detail

    - #### classLoader

          protected final ClassLoader classLoader

    - #### annotationSet

          protected final Set<String> annotationSet

    - #### metaAnnotationMap

          protected final Map<String,Set<String>> metaAnnotationMap

    - #### attributesMap

          protected final LinkedMultiValueMap<String,AnnotationAttributes> attributesMap

      Declared as a `LinkedMultiValueMap` instead of a `MultiValueMap` to ensure that the hierarchical ordering of the entries is preserved.
      See Also:
        `AnnotationReadingVisitorUtils.getMergedAnnotationAttributes(LinkedMultiValueMap, String)`

    - #### methodMetadataSet

          protected final Set<MethodMetadata> methodMetadataSet

  - ### Constructor Detail

    - #### AnnotationMetadataReadingVisitor

          public AnnotationMetadataReadingVisitor(ClassLoader classLoader)

  - ### Method Detail

    - #### visitMethod

          public MethodVisitor visitMethod(int access,
                                           String name,
                                           String desc,
                                           String signature,
                                           String[] exceptions)

      Description copied from class: `ClassVisitor`
      Visits a method of the class. This method must return a new `MethodVisitor` instance (or `null`) each time it is called, i.e., it should not return a previously returned visitor.
      Parameters:
        `access` - the method's access flags (see `Opcodes`). This parameter also indicates if the method is synthetic and/or deprecated.
        `name` - the method's name.
        `desc` - the method's descriptor (see `Type`).
        `signature` - the method's signature. May be `null` if the method parameters, return type and exceptions do not use generic types.
        `exceptions` - the internal names of the method's exception classes (see `getInternalName`). May be `null`.
      Returns:
        an object to visit the byte code of the method, or `null` if this class visitor is not interested in visiting the code of this method.

    - #### visitAnnotation

          public AnnotationVisitor visitAnnotation(String desc,
                                                   boolean visible)

      Description copied from class: `ClassVisitor`
      Visits an annotation of the class.
      Parameters:
        `desc` - the class descriptor of the annotation class.
        `visible` - `true` if the annotation is visible at runtime.
      Returns:
        a visitor to visit the annotation values, or `null` if this visitor is not interested in visiting this annotation.

    - #### getAnnotationTypes

          public Set<String> getAnnotationTypes()

      Description copied from interface: `AnnotationMetadata`
      Return the names of all annotation types that are present on the underlying class.
      Specified by:
        `getAnnotationTypes` in interface `AnnotationMetadata`
      Returns:
        the annotation type names

    - #### getMetaAnnotationTypes

          public Set<String> getMetaAnnotationTypes(String annotationType)

      Description copied from interface: `AnnotationMetadata`
      Return the names of all meta-annotation types present on the given annotation type on the underlying class.
      Specified by:
        `getMetaAnnotationTypes` in interface `AnnotationMetadata`
      Parameters:
        `annotationType` - the meta-annotation type to look for
      Returns:
        the meta-annotation type names

    - #### hasAnnotation

          public boolean hasAnnotation(String annotationType)

      Description copied from interface: `AnnotationMetadata`
      Determine whether an annotation of the given type is present on the underlying class.
      Specified by:
        `hasAnnotation` in interface `AnnotationMetadata`
      Parameters:
        `annotationType` - the annotation type to look for
      Returns:
        whether a matching annotation is present

    - #### hasMetaAnnotation

          public boolean hasMetaAnnotation(String metaAnnotationType)

      Description copied from interface: `AnnotationMetadata`
      Determine whether the underlying class has an annotation that is itself annotated with the meta-annotation of the given type.
      Specified by:
        `hasMetaAnnotation` in interface `AnnotationMetadata`
      Parameters:
        `metaAnnotationType` - the meta-annotation type to look for
      Returns:
        whether a matching meta-annotation is present

    - #### isAnnotated

          public boolean isAnnotated(String annotationType)

      Description copied from interface: `AnnotatedTypeMetadata`
      Determine whether the underlying type has an annotation or meta-annotation of the given type defined.

      If this method returns `true`, then `AnnotatedTypeMetadata.getAnnotationAttributes(java.lang.String)` will return a non-null Map.

      Specified by:
        `isAnnotated` in interface `AnnotatedTypeMetadata`
      Parameters:
        `annotationType` - the annotation type to look for
      Returns:
        whether a matching annotation is defined

    - #### getAnnotationAttributes

          public AnnotationAttributes getAnnotationAttributes(String annotationType)

      Description copied from interface: `AnnotatedTypeMetadata`
      Retrieve the attributes of the annotation of the given type, if any (i.e. if defined on the underlying class, as direct annotation or as meta-annotation).
      Specified by:
        `getAnnotationAttributes` in interface `AnnotatedTypeMetadata`
      Parameters:
        `annotationType` - the annotation type to look for
      Returns:
        a Map of attributes, with the attribute name as key (e.g. "value") and the defined attribute value as Map value. This return value will be `null` if no matching annotation is defined.

    - #### getAnnotationAttributes

          public AnnotationAttributes getAnnotationAttributes(String annotationType,
                                                              boolean classValuesAsString)

      Description copied from interface: `AnnotatedTypeMetadata`
      Retrieve the attributes of the annotation of the given type, if any (i.e. if defined on the underlying class, as direct annotation or as meta-annotation).
      Specified by:
        `getAnnotationAttributes` in interface `AnnotatedTypeMetadata`
      Parameters:
        `annotationType` - the annotation type to look for
        `classValuesAsString` - whether to convert class references to String class names for exposure as values in the returned Map, instead of Class references which might potentially have to be loaded first
      Returns:
        a Map of attributes, with the attribute name as key (e.g. "value") and the defined attribute value as Map value. This return value will be `null` if no matching annotation is defined.

    - #### getAllAnnotationAttributes

          public MultiValueMap<String,Object> getAllAnnotationAttributes(String annotationType)

      Description copied from interface: `AnnotatedTypeMetadata`
      Retrieve all attributes of all annotations of the given type, if any (i.e. if defined on the underlying type (`class` or `method`), as direct annotation or as meta-annotation).
      Specified by:
        `getAllAnnotationAttributes` in interface `AnnotatedTypeMetadata`
      Parameters:
        `annotationType` - the annotation type to look for
      Returns:
        a MultiMap of attributes, with the attribute name as key (e.g. "value") and a list of the defined attribute values as Map value. This return value will be `null` if no matching annotation is defined.
      See Also:
        `AnnotatedTypeMetadata.getAllAnnotationAttributes(String, boolean)`

    - #### getAllAnnotationAttributes

          public MultiValueMap<String,Object> getAllAnnotationAttributes(String annotationType,
                                                                         boolean classValuesAsString)

      Description copied from interface: `AnnotatedTypeMetadata`
      Retrieve all attributes of all annotations of the given type, if any (i.e. if defined on the underlying type (`class` or `method`), as direct annotation or as meta-annotation).
      Specified by:
        `getAllAnnotationAttributes` in interface `AnnotatedTypeMetadata`
      Parameters:
        `annotationType` - the annotation type to look for
        `classValuesAsString` - whether to convert class references to String
      Returns:
        a MultiMap of attributes, with the attribute name as key (e.g. "value") and a list of the defined attribute values as Map value. This return value will be `null` if no matching annotation is defined.
      See Also:
        `AnnotatedTypeMetadata.getAllAnnotationAttributes(String)`

    - #### hasAnnotatedMethods

          public boolean hasAnnotatedMethods(String annotationType)

      Description copied from interface: `AnnotationMetadata`
      Determine whether the underlying class has any methods that are annotated (or meta-annotated) with the given annotation type.
      Specified by:
        `hasAnnotatedMethods` in interface `AnnotationMetadata`

    - #### getAnnotatedMethods

          public Set<MethodMetadata> getAnnotatedMethods(String annotationType)

      Description copied from interface: `AnnotationMetadata`
      Retrieve the method metadata for all methods that are annotated (or meta-annotated) with the given annotation type.

      For any returned method, `AnnotatedTypeMetadata.isAnnotated(java.lang.String)` will return `true` for the given annotation type.

      Specified by:
        `getAnnotatedMethods` in interface `AnnotationMetadata`
      Parameters:
        `annotationType` - the annotation type to look for
      Returns:
        a set of `MethodMetadata` for methods that have a matching annotation. The return value will be an empty set if no methods match the annotation type.

    - #### visit

          public void visit(int version,
                            int access,
                            String name,
                            String signature,
                            String supername,
                            String[] interfaces)

      Description copied from class: `ClassVisitor`
      Visits the header of the class.
      Overrides:
        `visit` in class `ClassVisitor`
      Parameters:
        `version` - the class version.
        `access` - the class's access flags (see `Opcodes`). This parameter also indicates if the class is deprecated.
        `name` - the internal name of the class (see `getInternalName`).
        `signature` - the signature of this class. May be `null` if the class is not a generic one, and does not extend or implement generic classes or interfaces.
        `supername` - the internal of name of the super class (see `getInternalName`). For interfaces, the super class is `Object`. May be `null`, but only for the `Object` class.
        `interfaces` - the internal names of the class's interfaces (see `getInternalName`). May be `null`.

    - #### visitOuterClass

          public void visitOuterClass(String owner,
                                      String name,
                                      String desc)

      Description copied from class: `ClassVisitor`
      Visits the enclosing class of the class. This method must be called only if the class has an enclosing class.
      Overrides:
        `visitOuterClass` in class `ClassVisitor`
      Parameters:
        `owner` - internal name of the enclosing class of the class.
        `name` - the name of the method that contains the class, or `null` if the class is not enclosed in a method of its enclosing class.
        `desc` - the descriptor of the method that contains the class, or `null` if the class is not enclosed in a method of its enclosing class.

    - #### visitInnerClass

          public void visitInnerClass(String name,
                                      String outerName,
                                      String innerName,
                                      int access)

      Description copied from class: `ClassVisitor`
      Visits information about an inner class. This inner class is not necessarily a member of the class being visited.
      Overrides:
        `visitInnerClass` in class `ClassVisitor`
      Parameters:
        `name` - the internal name of an inner class (see `getInternalName`).
        `outerName` - the internal name of the class to which the inner class belongs (see `getInternalName`). May be `null` for not member classes.
        `innerName` - the (simple) name of the inner class inside its enclosing class. May be `null` for anonymous inner classes.
        `access` - the access flags of the inner class as originally declared in the enclosing class.

    - #### visitSource

          public void visitSource(String source,
                                  String debug)

      Description copied from class: `ClassVisitor`
      Visits the source of the class.
      Overrides:
        `visitSource` in class `ClassVisitor`
      Parameters:
        `source` - the name of the source file from which the class was compiled. May be `null`.
        `debug` - additional debug information to compute the correspondance between source and compiled elements of the class. May be `null`.

    - #### visitAttribute

          public void visitAttribute(Attribute attr)

      Description copied from class: `ClassVisitor`
      Visits a non standard attribute of the class.
      Overrides:
        `visitAttribute` in class `ClassVisitor`
      Parameters:
        `attr` - an attribute.

    - #### visitField

          public FieldVisitor visitField(int access,
                                         String name,
                                         String desc,
                                         String signature,
                                         Object value)

      Description copied from class: `ClassVisitor`
      Visits a field of the class.
      Overrides:
        `visitField` in class `ClassVisitor`
      Parameters:
        `access` - the field's access flags (see `Opcodes`). This parameter also indicates if the field is synthetic and/or deprecated.
        `name` - the field's name.
        `desc` - the field's descriptor (see `Type`).
        `signature` - the field's signature. May be `null` if the field's type does not use generic types.
        `value` - the field's initial value. This parameter, which may be `null` if the field does not have an initial value, must be an `Integer`, a `Float`, a `Long`, a `Double` or a `String` (for `int`, `float`, `long` or `String` fields respectively). This parameter is only used for static fields. Its value is ignored for non static fields, which must be initialized through bytecode instructions in constructors or methods.
      Returns:
        a visitor to visit field annotations and attributes, or `null` if this class visitor is not interested in visiting these annotations and attributes.

    - #### visitEnd

          public void visitEnd()

      Description copied from class: `ClassVisitor`
      Visits the end of the class. This method, which is the last one to be called, is used to inform the visitor that all the fields and methods of the class have been visited.
      Overrides:
        `visitEnd` in class `ClassVisitor`

    - #### getClassName

          public String getClassName()

      Description copied from interface: `ClassMetadata`
      Return the name of the underlying class.
      Specified by:
        `getClassName` in interface `ClassMetadata`

    - #### isInterface

          public boolean isInterface()

      Description copied from interface: `ClassMetadata`
      Return whether the underlying class represents an interface.
      Specified by:
        `isInterface` in interface `ClassMetadata`

    - #### isAbstract

          public boolean isAbstract()

      Description copied from interface: `ClassMetadata`
      Return whether the underlying class is marked as abstract.
      Specified by:
        `isAbstract` in interface `ClassMetadata`

    - #### isConcrete

          public boolean isConcrete()

      Description copied from interface: `ClassMetadata`
      Return whether the underlying class represents a concrete class, i.e. neither an interface nor an abstract class.
      Specified by:
        `isConcrete` in interface `ClassMetadata`

    - #### isFinal

          public boolean isFinal()

      Description copied from interface: `ClassMetadata`
      Return whether the underlying class is marked as 'final'.
      Specified by:
        `isFinal` in interface `ClassMetadata`

    - #### isIndependent

          public boolean isIndependent()

      Description copied from interface: `ClassMetadata`
      Determine whether the underlying class is independent, i.e. whether it is a top-level class or a nested class (static inner class) that can be constructed independent from an enclosing class.
      Specified by:
        `isIndependent` in interface `ClassMetadata`

    - #### hasEnclosingClass

          public boolean hasEnclosingClass()

      Description copied from interface: `ClassMetadata`
      Return whether the underlying class has an enclosing class (i.e. the underlying class is an inner/nested class or a local class within a method).

      If this method returns `false`, then the underlying class is a top-level class.

      Specified by:
        `hasEnclosingClass` in interface `ClassMetadata`

    - #### getEnclosingClassName

          public String getEnclosingClassName()

      Description copied from interface: `ClassMetadata`
      Return the name of the enclosing class of the underlying class, or `null` if the underlying class is a top-level class.
      Specified by:
        `getEnclosingClassName` in interface `ClassMetadata`

    - #### hasSuperClass

          public boolean hasSuperClass()

      Description copied from interface: `ClassMetadata`
      Return whether the underlying class has a super class.
      Specified by:
        `hasSuperClass` in interface `ClassMetadata`

    - #### getSuperClassName

          public String getSuperClassName()

      Description copied from interface: `ClassMetadata`
      Return the name of the super class of the underlying class, or `null` if there is no super class defined.
      Specified by:
        `getSuperClassName` in interface `ClassMetadata`

    - #### getInterfaceNames

          public String[] getInterfaceNames()

      Description copied from interface: `ClassMetadata`
      Return the names of all interfaces that the underlying class implements, or an empty array if there are none.
      Specified by:
        `getInterfaceNames` in interface `ClassMetadata`

    - #### getMemberClassNames

          public String[] getMemberClassNames()

      Description copied from interface: `ClassMetadata`
      Return the names of all classes declared as members of the class represented by this ClassMetadata object. This includes public, protected, default (package) access, and private classes and interfaces declared by the class, but excludes inherited classes and interfaces. An empty array is returned if no member classes or interfaces exist.
      Specified by:
        `getMemberClassNames` in interface `ClassMetadata`